require("SignProtector.nut");

class HighwaySigns extends SignProtector
{
	vehiclesOnHighway = {};

	function IsOnHighway();
	function IsOnHighwaySign();
	function ChangeToIn();
	function ChangeToOut();
}

function HighwaySigns::IsOnHighway(vehicle)
{
	if (vehicle.IsRoadVehicle() && vehicle.IsRunningVehicle())
	{
		local isOnHighwaySign = this.IsOnHighwaySign(vehicle);
		local wasOnHighway = this.vehiclesOnHighway.rawin(vehicle.vehicleID);
		
		if (isOnHighwaySign)
		{
			if (wasOnHighway)
			{
				local currentVehicleLocationTileID = vehicle.GetLocationTileID();
				local wasOnHighwayTileID = this.vehiclesOnHighway[vehicle.vehicleID];
				
				if (currentVehicleLocationTileID != wasOnHighwayTileID)
				{
					this.vehiclesOnHighway[vehicle.vehicleID] <- currentVehicleLocationTileID;
					return this.ChangeToOut(vehicle);
				}
			}
			else
				return this.ChangeToIn(vehicle);
		}
		
		return wasOnHighway;
	}
	
	return false;
}

function HighwaySigns::IsOnHighwaySign(vehicle)
{
	foreach (highwaySign in this.signs)
	{
		if (highwaySign.locationTileID == vehicle.GetLocationTileID())
			return true;
	}
	
	return false;
}

function HighwaySigns::ChangeToIn(vehicle)
{
	this.vehiclesOnHighway[vehicle.vehicleID] <- vehicle.GetLocationTileID();
	return true;
}

function HighwaySigns::ChangeToOut(vehicle)
{
	this.vehiclesOnHighway.rawdelete(vehicle.vehicleID);
	return false;
}