class Sign
{
	signID = null;
	ownerCompanyID = null;
	text = null;
	locationTileID = null;
	
	constructor(signID)
    {
		if (GSSign.IsValidSign(signID))
		{
			this.signID = signID;
			this.ownerCompanyID = GSSign.GetOwner(this.signID);
			this.text = GSSign.GetName(this.signID);
			this.locationTileID = GSSign.GetLocation(this.signID);
		}
    }
	
	function SetChangesSaved();
	function IsSameOwner();
	function IsTextChanged();
	function RevertCurrentChanges();
}

function Sign::IsSameOwner(sign)
{
	return this.ownerCompanyID == sign.ownerCompanyID;
}

function Sign::IsTextChanged(sign)
{
	return this.text != sign.text;
}

function Sign::SetChangesSaved(sign)
{
	if (this.signID == sign.signID)
		this.text = sign.text;
}

function Sign::RevertCurrentChanges(sign)
{
	local mode = GSCompanyMode(sign.ownerCompanyID);
	GSSign.SetName(this.signID, this.text);
}